
/* : : generated by proto : : */
/***********************************************************************
*                                                                      *
*               This software is part of the ast package               *
*          Copyright (c) 1985-2013 AT&T Intellectual Property          *
*                      and is licensed under the                       *
*                 Eclipse Public License, Version 1.0                  *
*                    by AT&T Intellectual Property                     *
*                                                                      *
*                A copy of the License is available at                 *
*          http://www.eclipse.org/org/documents/epl-v10.html           *
*         (with md5 checksum b35adb5213ca9657e911e9befb180842)         *
*                                                                      *
*              Information and Software Systems Research               *
*                            AT&T Research                             *
*                           Florham Park NJ                            *
*                                                                      *
*               Glenn Fowler <glenn.s.fowler@gmail.com>                *
*                    David Korn <dgkorn@gmail.com>                     *
*                     Phong Vo <phongvo@gmail.com>                     *
*                                                                      *
***********************************************************************/
                  
/*
 * Advanced Software Technology Library
 * AT&T Research
 *
 * std + posix + ast
 */

#ifndef _AST_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#if !defined(__LINKAGE__)
#define __LINKAGE__		/* 2004-08-11 transition */
#endif

#define _AST_H		1

#ifndef _AST_STD_H
#include <ast_std.h>
#endif

#ifndef _SFIO_H
#include <sfio.h>
#endif

#ifndef	ast
#define ast		_ast_info
#endif

#ifndef PATH_MAX
#define PATH_MAX	1024
#endif

/*
 * workaround botched headers that assume <stdio.h>
 */

#ifndef FILE
#ifndef _SFIO_H
struct _sfio_s;
#endif
#define FILE		struct _sfio_s
#ifndef	__FILE_typedef
#define __FILE_typedef	1
#endif
#ifndef _FILEDEFED
#define _FILEDEFED	1
#endif
#endif

/*
 * exit() support -- this matches shell exit codes
 */

#define EXIT_BITS	8			/* # exit status bits	*/

#define EXIT_USAGE	2			/* usage exit code	*/
#define EXIT_QUIT	((1<<(EXIT_BITS))-1)	/* parent should quit	*/
#define EXIT_NOTFOUND	((1<<(EXIT_BITS-1))-1)	/* command not found	*/
#define EXIT_NOEXEC	((1<<(EXIT_BITS-1))-2)	/* other exec error	*/

#define EXIT_CODE(x)	((x)&((1<<EXIT_BITS)-1))
#define EXIT_CORE(x)	(EXIT_CODE(x)|(1<<EXIT_BITS)|(1<<(EXIT_BITS-1)))
#define EXIT_TERM(x)	(EXIT_CODE(x)|(1<<EXIT_BITS))

/*
 * NOTE: for compatibility the following work for EXIT_BITS={7,8}
 */

#define EXIT_STATUS(x)	(((x)&((1<<(EXIT_BITS-2))-1))?(x):EXIT_CODE((x)>>EXIT_BITS))

#define EXITED_CORE(x)	(((x)&((1<<EXIT_BITS)|(1<<(EXIT_BITS-1))))==((1<<EXIT_BITS)|(1<<(EXIT_BITS-1)))||((x)&((1<<(EXIT_BITS-1))|(1<<(EXIT_BITS-2))))==((1<<(EXIT_BITS-1))|(1<<(EXIT_BITS-2))))
#define EXITED_TERM(x)	((x)&((1<<EXIT_BITS)|(1<<(EXIT_BITS-1))))

/*
 * astconflist() flags
 */

#define ASTCONF_parse		0x0001
#define ASTCONF_write		0x0002
#define ASTCONF_read		0x0004
#define ASTCONF_lower		0x0008
#define ASTCONF_base		0x0010
#define ASTCONF_defined		0x0020
#define ASTCONF_quote		0x0040
#define ASTCONF_table		0x0080
#define ASTCONF_matchcall	0x0100
#define ASTCONF_matchname	0x0200
#define ASTCONF_matchstandard	0x0400
#define ASTCONF_error		0x0800
#define ASTCONF_system		0x1000
#define ASTCONF_AST		0x2000

/*
 * pathcanon()/pathdev() flags and info
 */

#define PATH_PHYSICAL		0x001
#define PATH_DOTDOT		0x002
#define PATH_EXISTS		0x004
#define PATH_DEV		0x008
#define PATH_ABSOLUTE		0x010	/* NOTE: shared with pathaccess() below */
#define PATH_CANON		0x020
#define PATH_DROP_HEAD_SLASH2	0x040
#define PATH_DROP_TAIL_SLASH	0x080
#define PATH_EXCEPT_LAST	0x100
#define PATH_VERIFIED(n)	(((n)&0xfffff)<<12)
#define PATH_GET_VERIFIED(n)	(((n)>>12)&0xfffff)

typedef struct Pathpart_s
{
	unsigned short	offset;
	unsigned short	size;
} Pathpart_t;

typedef struct Pathdev_s
{
	int		fd;
	int		oflags;
	pid_t		pid;
	Pathpart_t	prot;
	Pathpart_t	host;
	Pathpart_t	port;
	Pathpart_t	path;
} Pathdev_t;

/*
 * pathaccess() flags
 */

#define PATH_READ	0x04
#define PATH_WRITE	0x02
#define PATH_EXECUTE	0x01
#define	PATH_REGULAR	0x08
/* NOTE: PATH_ABSOLUTE shared with pathcanon()/pathdev() above */

/*
 * touch() flags
 */

#define PATH_TOUCH_CREATE	01
#define PATH_TOUCH_VERBATIM	02

/*
 * pathcheck() info
 */

typedef struct
{
	unsigned long	date;
	char*		feature;
	char*		host;
	char*		user;
} Pathcheck_t;

/*
 * strgrpmatch() flags
 */

#define STR_MAXIMAL	0x01		/* maximal match		*/
#define STR_LEFT	0x02		/* implicit left anchor		*/
#define STR_RIGHT	0x04		/* implicit right anchor	*/
#define STR_ICASE	0x08		/* ignore case			*/
#define STR_GROUP	0x10		/* (|&) inside [@|&](...) only	*/
#define STR_INT		0x20		/* deprecated int* match array	*/

/*
 * fmtquote() flags
 */

#define FMT_ALWAYS	0x01		/* always quote			*/
#define FMT_ESCAPED	0x02		/* already escaped		*/
#define FMT_SHELL	0x04		/* escape $ ` too		*/
#define FMT_WIDE	0x08		/* don't escape 8 bit chars	*/
#define FMT_PARAM	0x10		/* disable FMT_SHELL ${$( quote	*/

/*
 * chrexp() flags
 */

#define FMT_EXP_CHAR	0x020		/* expand single byte chars	*/
#define FMT_EXP_LINE	0x040		/* expand \n and \r		*/
#define FMT_EXP_WIDE	0x080		/* expand \u \U \x wide chars	*/
#define FMT_EXP_NOCR	0x100		/* skip \r			*/
#define FMT_EXP_NONL	0x200		/* skip \n			*/

/*
 * multibyte macros
 */

#define mbmax()			(ast.mb_cur_max)

#define mbcoll()		(ast.mb_xfrm!=0)
#define mbwide()		(mbmax()>1)

#define mbwidth(w)		(ast.mb_width?(*ast.mb_width)(w):1)
#define mbxfrm(t,f,n)		(mbcoll()?(*ast.mb_xfrm)((char*)(t),(char*)(f),n):0)
#define mbalpha(w)		(ast.mb_alpha?(*ast.mb_alpha)(w):isalpha((w)&0xff))

#define mbsrtowcs(w,s,n,q)	(*ast._ast_mbsrtowcs)((s),(w),(n),(mbstate_t*)(q))
#define wcsrtombs(s,w,n,q)	(*ast._ast_wcsrtombs)((s),(w),(n),(mbstate_t*)(q))

/* the converse does not always hold! */
#define utf32invalid(u)	((u)>0x0010FFFF||(u)>=0x0000D800&&(u)<=0x0000DFFF||(u)>=0xFFFE&&(u)<=0xFFFF)

#define UTF8_LEN_MAX		6	/* UTF-8 only uses 5 */

/*
 * common macros
 */

#define elementsof(x)	(sizeof(x)/sizeof(x[0]))
#define getconf(x)	strtol(astconf((x),NiL,NiL),NiL,0)
#define integralof(x)	(((char*)(x))-((char*)0))
#define newof(p,t,n,x)	((p)?(t*)realloc((char*)(p),sizeof(t)*(n)+(x)):(t*)calloc(1,sizeof(t)*(n)+(x)))
#define oldof(p,t,n,x)	((p)?(t*)realloc((char*)(p),sizeof(t)*(n)+(x)):(t*)malloc(sizeof(t)*(n)+(x)))
#define pointerof(x)	((__V_*)((char*)0+(x)))
#define roundof(x,y)	(((x)+(y)-1)&~((y)-1))
#define ssizeof(x)	((int)sizeof(x))

#define streq(a,b)	(*(a)==*(b)&&!strcmp(a,b))
#define strneq(a,b,n)	(*(a)==*(b)&&!strncmp(a,b,n))
#define strsignal(s)	fmtsignal(s)

#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define NiL		0
#define NoP(x)		(void)(x)
#else
#define NiL		((char*)0)
#define NoP(x)		(&x,1)
#endif

#if !defined(NoF)
#if defined(__STDC__) || defined(__STDPP__)
#define NoF(x)		void _DATA_ ## x () {}
#else
#define NoF(x)		void _DATA_/**/x () {}
#endif
#if !defined(_DATA_)
#define _DATA_
#endif
#endif

#if !defined(NoN)
#if defined(__STDC__) || defined(__STDPP__)
#define NoN(x)		void _STUB_ ## x () {}
#else
#define NoN(x)		void _STUB_/**/x () {}
#endif
#if !defined(_STUB_)
#define _STUB_
#endif
#endif

#define NOT_USED(x)	NoP(x)

typedef int (*Ast_confdisc_f) __PROTO__((const char*, const char*, const char*));
typedef int (*Strcmp_context_f) __PROTO__((const char*, const char*, __V_*));
typedef int (*Strcmp_f) __PROTO__((const char*, const char*));

#include <ast_errorf.h>

#ifndef _VMALLOC_H
struct Vmdisc_s;
#endif

#if _BLD_ast && defined(__EXPORT__)
#undef __MANGLE__
#define __MANGLE__ __LINKAGE__		__EXPORT__
#endif

extern __MANGLE__ char*		astgetconf __PROTO__((const char*, const char*, const char*, int, Error_f));
extern __MANGLE__ char*		astconf __PROTO__((const char*, const char*, const char*));
extern __MANGLE__ Ast_confdisc_f	astconfdisc __PROTO__((Ast_confdisc_f));
extern __MANGLE__ void		astconflist __PROTO__((Sfio_t*, const char*, int, const char*));
extern __MANGLE__ off_t		astcopy __PROTO__((int, int, off_t));
extern __MANGLE__ int		astlicense __PROTO__((char*, int, char*, char*, int, int, int));
extern __MANGLE__ int		astquery __PROTO__((int, const char*, ...));
extern __MANGLE__ void		astwinsize __PROTO__((int, int*, int*));

extern __MANGLE__ ssize_t		base64encode __PROTO__((const __V_*, size_t, __V_**, __V_*, size_t, __V_**));
extern __MANGLE__ ssize_t		base64decode __PROTO__((const __V_*, size_t, __V_**, __V_*, size_t, __V_**));
extern __MANGLE__ int		chresc __PROTO__((const char*, char**));
extern __MANGLE__ int		chrexp __PROTO__((const char*, char**, int*, int));
extern __MANGLE__ int		chrtoi __PROTO__((const char*));
extern __MANGLE__ char*		conformance __PROTO__((const char*, size_t));
extern __MANGLE__ ssize_t		debug_printf __PROTO__((int, const char*, ...));
extern __MANGLE__ int		eaccess __PROTO__((const char*, int));
extern __MANGLE__ char*		fmtbase __PROTO__((intmax_t, int, int));
#define fmtbasell(a,b,c) fmtbase(a,b,c) /* until 2014-01-01 */
extern __MANGLE__ char*		fmtbuf __PROTO__((size_t));
extern __MANGLE__ char*		fmtclock __PROTO__((Sfulong_t));
extern __MANGLE__ char*		fmtelapsed __PROTO__((unsigned long, int));
extern __MANGLE__ char*		fmterror __PROTO__((int));
extern __MANGLE__ char*		fmtesc __PROTO__((const char*));
extern __MANGLE__ char*		fmtesq __PROTO__((const char*, const char*));
extern __MANGLE__ char*		fmtident __PROTO__((const char*));
extern __MANGLE__ char*		fmtip4 __PROTO__((uint32_t, int));
extern __MANGLE__ char*		fmtfmt __PROTO__((const char*));
extern __MANGLE__ char*		fmtgid __PROTO__((int));
extern __MANGLE__ char*		fmtint __PROTO__((intmax_t, int));
extern __MANGLE__ char*		fmtmatch __PROTO__((const char*));
extern __MANGLE__ char*		fmtmode __PROTO__((int, int));
extern __MANGLE__ char*		fmtnesq __PROTO__((const char*, const char*, size_t));
extern __MANGLE__ char*		fmtnum __PROTO__((unsigned long, int));
extern __MANGLE__ char*		fmtperm __PROTO__((int));
extern __MANGLE__ char*		fmtquote __PROTO__((const char*, const char*, const char*, size_t, int));
extern __MANGLE__ char*		fmtre __PROTO__((const char*));
extern __MANGLE__ char*		fmtscale __PROTO__((Sfulong_t, int));
extern __MANGLE__ char*		fmtsignal __PROTO__((int));
extern __MANGLE__ char*		fmttime __PROTO__((const char*, time_t));
extern __MANGLE__ char*		fmtuid __PROTO__((int));
extern __MANGLE__ char*		fmtversion __PROTO__((unsigned long));
extern __MANGLE__ __V_*		memdup __PROTO__((const __V_*, size_t));
extern __MANGLE__ void		memfatal __PROTO__((void));
extern __MANGLE__ int		memfatal_20130509 __PROTO__((struct Vmdisc_s*));
extern __MANGLE__ unsigned int	memhash __PROTO__((const __V_*, int));
extern __MANGLE__ unsigned long	memsum __PROTO__((const __V_*, int, unsigned long));
extern __MANGLE__ char*		pathaccess __PROTO__((char*, const char*, const char*, const char*, int));
extern __MANGLE__ char*		pathaccess_20100601 __PROTO__((const char*, const char*, const char*, int, char*, size_t));
extern __MANGLE__ char*		pathbin __PROTO__((void));
extern __MANGLE__ char*		pathcanon __PROTO__((char*, int));
extern __MANGLE__ char*		pathcanon_20100601 __PROTO__((char*, size_t, int));
extern __MANGLE__ char*		pathcat __PROTO__((char*, const char*, int, const char*, const char*));
extern __MANGLE__ char*		pathcat_20100601 __PROTO__((const char*, int, const char*, const char*, char*, size_t));
extern __MANGLE__ int		pathcd __PROTO__((const char*, const char*));
extern __MANGLE__ int		pathcheck __PROTO__((const char*, const char*, Pathcheck_t*));
extern __MANGLE__ char*		pathdev __PROTO__((int, const char*, char*, size_t, int, Pathdev_t*));
extern __MANGLE__ int		pathexists __PROTO__((char*, int));
extern __MANGLE__ char*		pathfind __PROTO__((const char*, const char*, const char*, char*, size_t));
extern __MANGLE__ int		pathgetlink __PROTO__((const char*, char*, int));
extern __MANGLE__ int		pathinclude __PROTO__((const char*));
extern __MANGLE__ char*		pathkey __PROTO__((char*, char*, const char*, const char*, const char*));
extern __MANGLE__ char*		pathkey_20100601 __PROTO__((const char*, const char*, const char*, char*, size_t, char*, size_t));
extern __MANGLE__ size_t		pathnative __PROTO__((const char*, char*, size_t));
extern __MANGLE__ int		pathopen __PROTO__((int, const char*, char*, size_t, int, int, mode_t));
extern __MANGLE__ char*		pathpath __PROTO__((char*, const char*, const char*, int));
extern __MANGLE__ char*		pathpath_20100601 __PROTO__((const char*, const char*, int, char*, size_t));
extern __MANGLE__ size_t		pathposix __PROTO__((const char*, char*, size_t));
extern __MANGLE__ char*		pathprobe __PROTO__((char*, char*, const char*, const char*, const char*, int));
extern __MANGLE__ char*		pathprobe_20100601 __PROTO__((const char*, const char*, const char*, int, char*, size_t, char*, size_t));
extern __MANGLE__ size_t		pathprog __PROTO__((const char*, char*, size_t));
extern __MANGLE__ char*		pathrepl __PROTO__((char*, const char*, const char*));
extern __MANGLE__ char*		pathrepl_20100601 __PROTO__((char*, size_t, const char*, const char*));
extern __MANGLE__ int		pathsetlink __PROTO__((const char*, const char*));
extern __MANGLE__ char*		pathshell __PROTO__((void));
extern __MANGLE__ char*		pathtemp __PROTO__((char*, size_t, const char*, const char*, int*));
extern __MANGLE__ char*		pathtmp __PROTO__((char*, const char*, const char*, int*));
extern __MANGLE__ ssize_t		qpencode __PROTO__((const __V_*, size_t, __V_**, __V_*, size_t, __V_**));
extern __MANGLE__ ssize_t		qpdecode __PROTO__((const __V_*, size_t, __V_**, __V_*, size_t, __V_**));
extern __MANGLE__ char*		setenviron __PROTO__((const char*));
extern __MANGLE__ int		stracmp __PROTO__((const char*, const char*));
extern __MANGLE__ char*		strcopy __PROTO__((char*, const char*));
extern __MANGLE__ unsigned long	strelapsed __PROTO__((const char*, char**, int));
extern __MANGLE__ int		stresc __PROTO__((char*));
extern __MANGLE__ int		strexp __PROTO__((char*, int));
extern __MANGLE__ long		streval __PROTO__((const char*, char**, long(*)(const char*, char**)));
extern __MANGLE__ long		strexpr __PROTO__((const char*, char**, long(*)(const char*, char**, __V_*), __V_*));
extern __MANGLE__ int		strgid __PROTO__((const char*));
extern __MANGLE__ int		strgrpmatch __PROTO__((const char*, const char*, int*, int, int));
extern __MANGLE__ int		strgrpmatch_20120528 __PROTO__((const char*, const char*, ssize_t*, int, int));
extern __MANGLE__ int		strngrpmatch __PROTO__((const char*, size_t, const char*, ssize_t*, int, int));
extern __MANGLE__ unsigned int	strhash __PROTO__((const char*));
extern __MANGLE__ __V_*		strlook __PROTO__((const __V_*, size_t, const char*));
extern __MANGLE__ int		strmatch __PROTO__((const char*, const char*));
extern __MANGLE__ int		strmode __PROTO__((const char*));
extern __MANGLE__ int		strnacmp __PROTO__((const char*, const char*, size_t));
extern __MANGLE__ char*		strncopy __PROTO__((char*, const char*, size_t));
extern __MANGLE__ int		strnpcmp __PROTO__((const char*, const char*, size_t));
extern __MANGLE__ double		strntod __PROTO__((const char*, size_t, char**));
extern __MANGLE__ _ast_fltmax_t	strntold __PROTO__((const char*, size_t, char**));
extern __MANGLE__ long		strntol __PROTO__((const char*, size_t, char**, int));
extern __MANGLE__ intmax_t		strntoll __PROTO__((const char*, size_t, char**, int));
extern __MANGLE__ long		strnton __PROTO__((const char*, size_t, char**, char*, int));
extern __MANGLE__ unsigned long	strntoul __PROTO__((const char*, size_t, char**, int));
extern __MANGLE__ intmax_t		strntonll __PROTO__((const char*, size_t, char**, char*, int));
extern __MANGLE__ uintmax_t	strntoull __PROTO__((const char*, size_t, char**, int));
extern __MANGLE__ int		strnvcmp __PROTO__((const char*, const char*, size_t));
extern __MANGLE__ int		stropt __PROTO__((const char*, const __V_*, int, int(*)(__V_*, const __V_*, int, const char*), __V_*));
extern __MANGLE__ int		strpcmp __PROTO__((const char*, const char*));
extern __MANGLE__ int		strperm __PROTO__((const char*, char**, int));
extern __MANGLE__ __V_*		strpsearch __PROTO__((const __V_*, size_t, size_t, const char*, char**));
extern __MANGLE__ __V_*		strsearch __PROTO__((const __V_*, size_t, size_t, Strcmp_f, const char*, __V_*));
extern __MANGLE__ void		strsort __PROTO__((char**, int, Strcmp_f));
extern __MANGLE__ void		strsort_r __PROTO__((char**, size_t, Strcmp_context_f, __V_*));
extern __MANGLE__ char*		strsubmatch __PROTO__((const char*, const char*, int));
extern __MANGLE__ unsigned long	strsum __PROTO__((const char*, unsigned long));
extern __MANGLE__ char*		strtape __PROTO__((const char*, char**));
extern __MANGLE__ int		strtoip4 __PROTO__((const char*, char**, uint32_t*, unsigned char*));
extern __MANGLE__ long		strton __PROTO__((const char*, char**, char*, int));
extern __MANGLE__ intmax_t		strtonll __PROTO__((const char*, char**, char*, int));
extern __MANGLE__ int		struid __PROTO__((const char*));
extern __MANGLE__ int		struniq __PROTO__((char**, int));
extern __MANGLE__ int		strvcmp __PROTO__((const char*, const char*));

extern __MANGLE__ size_t		utf32toutf8 __PROTO__((char*, uint32_t));
extern __MANGLE__ size_t		utf8toutf32 __PROTO__((uint32_t*, const char*, size_t));
extern __MANGLE__ size_t		utf8toutf32v __PROTO__((uint32_t*, const char*));
extern __MANGLE__ size_t		utf8towc __PROTO__((wchar_t*, const char*, size_t));

extern __MANGLE__ ssize_t		utf32stowcs __PROTO__((wchar_t*, uint32_t*, size_t));
extern __MANGLE__ ssize_t		wcstoutf32s __PROTO__((uint32_t*, wchar_t*, size_t));

extern __MANGLE__ size_t		ast_mbrchar __PROTO__((wchar_t*, const char*, size_t, Mbstate_t*));

#undef __MANGLE__
#define __MANGLE__ __LINKAGE__

/*
 * C library global data symbols not prototyped by <unistd.h>
 */

#if !defined(environ) && defined(__DYNAMIC__)
#define	environ		__DYNAMIC__(environ)
#else
extern __MANGLE__ char**		environ;
#endif

#include <ast_debug.h>

#include <ast_api.h>

/* api specific mb/wc macros */

#if ASTAPI(20130913)

#define mbsinit(q)		(*(q)=ast._ast_mbstate_init.mb_state)
#define mbinit(q)		(*(q)=ast._ast_mbstate_init)
#define mberrno(q)		((q)->mb_errno)
#define mbsize(s,n,q)		(*ast._ast_mbrlen)((char*)(s),(n),(mbstate_t*)(q))
#define mbchar(w,s,n,q)		(((s)+=(ast_mbrchar)((wchar_t*)(w),(char*)(s),(n),(q))),(*(w)))
#define mbconv(s,w,q)		(*ast._ast_wcrtomb)((s),(w),(mbstate_t*)(q))

#define mbtinit(q)		(mbwide()?(mbinit(q),0):0)
#define mbtsize(s,n,q)		(mbwide()?mbsize((s),(n),(q)):(!!*(s)))
#define mbtchar(w,s,n,q)	(mbwide()?mbchar((w),(s),(n),(q)):(*(unsigned char*)(s++)))
#define mbtconv(s,w,q)		(mbwide()?mbconv((s),(w),(q)):((*(s)=(w)),1))

#else

#define mb2wc(w,p,n)		(*ast.mb_towc)(&(w),(char*)(p),(n))
#define mbinit()		(mbwide()?(*ast.mb_towc)((wchar_t*)0,(char*)0,mbmax()):0)
#define mbsize(p)		(mbwide()?(*ast.mb_len)((char*)(p),mbmax()):((p),1))
#define mbnsize(p,n)		(mbwide()?(*ast.mb_len)((char*)(p),n):((p),1))
#define mbconv(s,w)		(ast.mb_conv?(*ast.mb_conv)(s,w):((*(s)=(w)),1))

#define mbchar(p)		(mbwide() ? \
					(((ast.tmp_int=(*ast.mb_towc)(&ast.tmp_wchar,(char*)(p),mbmax()))>0) ? \
						({p+=ast.tmp_int;ast.tmp_wchar;}) : \
						({ast.tmp_int= *(unsigned char*)p;p+=ast.mb_sync+1;ast.tmp_int;})) : \
					(*(unsigned char*)(p++)))
#define mbnchar(p,n)		(mbwide() ? \
					(((ast.tmp_int=(*ast.mb_towc)(&ast.tmp_wchar,(char*)(p),n))>0) ? \
						({p+=ast.tmp_int;ast.tmp_wchar;}) : \
						({ast.tmp_int= *(unsigned char*)p;p+=ast.mb_sync+1;ast.tmp_int;})): \
					(*(unsigned char*)(p++)))
#endif

/* generic plugin version support */

#undef	AST_PLUGIN_VERSION
#define AST_PLUGIN_VERSION(v)	((v)>AST_VERSION?(v):AST_VERSION)

#if defined(__EXPORT__)
#undef __MANGLE__
#define __MANGLE__ __LINKAGE__		__EXPORT__
#endif

extern __MANGLE__ unsigned long	plugin_version __PROTO__((void));

#undef __MANGLE__
#define __MANGLE__ __LINKAGE__

#endif
