
/* : : generated by proto : : */
/***********************************************************************
*                                                                      *
*               This software is part of the ast package               *
*          Copyright (c) 1985-2013 AT&T Intellectual Property          *
*                      and is licensed under the                       *
*                 Eclipse Public License, Version 1.0                  *
*                    by AT&T Intellectual Property                     *
*                                                                      *
*                A copy of the License is available at                 *
*          http://www.eclipse.org/org/documents/epl-v10.html           *
*         (with md5 checksum b35adb5213ca9657e911e9befb180842)         *
*                                                                      *
*              Information and Software Systems Research               *
*                            AT&T Research                             *
*                           Florham Park NJ                            *
*                                                                      *
*               Glenn Fowler <glenn.s.fowler@gmail.com>                *
*                    David Korn <dgkorn@gmail.com>                     *
*                     Phong Vo <phongvo@gmail.com>                     *
*                                                                      *
***********************************************************************/
                  
/*
 * common ast debug definitions
 * include after the ast headers
 */

#ifndef _DEBUG_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#if !defined(__LINKAGE__)
#define __LINKAGE__		/* 2004-08-11 transition */
#endif

#define _DEBUG_H

#include <ast.h>
#include <error.h>

#if !defined(DEBUG) && _BLD_DEBUG
#define DEBUG		_BLD_DEBUG
#endif

#if DEBUG || _BLD_DEBUG

#define debug(x)	x
#define message(x)	do if (error_info.trace < 0) { error x; } while (0)
#define messagef(x)	do if (error_info.trace < 0) { errorf x; } while (0)

#define DEBUG_BEGTIME()		debug_elapsed(1)
#define DEBUG_GETTIME()		debug_elapsed(0)
#if defined(__STDC__) || defined(__STDPP__)
#define DEBUG_ASSERT(p)		((p) ? 0 : (debug_fatal(__FILE__, __LINE__, #p),0))
#else
#define DEBUG_ASSERT(p)		((p) ? 0 : (debug_fatal(__FILE__, __LINE__,"p"),0))
#endif
#define DEBUG_COUNT(n)		((n) += 1)
#define DEBUG_TALLY(c,n,v)	((c) ? ((n) += (v)) : (n))
#define DEBUG_INCREASE(n)	((n) += 1)
#define DEBUG_DECREASE(n)	((n) -= 1)
#define DEBUG_DECLARE(t,v)	t v;
#define DEBUG_SET(n,v)		((n) = (v))
#define DEBUG_MESSAGE(m)	debug_printf(2,"%s:%d: %s\n",__FILE__,__LINE__,m)
#define DEBUG_PRINT(fd,s,v)	debug_printf((fd),(s),(v))
#define DEBUG_WRITE(fd,d,n)	write((fd),(d),(n))
#define DEBUG_TEMP(temp)	(temp) /* debugging stuff that should be removed */
#define DEBUG_BREAK		break
#define DEBUG_CONTINUE		continue
#if defined(__STDC__) || defined(__STDPP__)
#define DEBUG_GOTO(label)	do { debug_printf(2, "%s:%d: goto %s\n", __FILE__, __LINE__, #label); goto label; } while(0)
#else
#define DEBUG_GOTO(label)	do { debug_printf(2, "%s:%d: goto %s\n", __FILE__, __LINE__,"label"); goto label; } while(0)
#endif
#if defined(__STDC__) || defined(__STDPP__)
#define DEBUG_RETURN(x)		do { debug_printf(2, "%s:%d: return %s\n", __FILE__, __LINE__, #x); return(x); } while(0)
#else
#define DEBUG_RETURN(x)		do { debug_printf(2, "%s:%d: return %s\n", __FILE__, __LINE__,"x"); return(x); } while(0)
#endif

#else

#define debug(x)
#define message(x)
#define messagef(x)

#define DEBUG_BEGTIME()
#define DEBUG_GETTIME()
#define DEBUG_ASSERT(p)
#define DEBUG_COUNT(n)
#define DEBUG_TALLY(c,n,v)
#define DEBUG_INCREASE(n)
#define DEBUG_DECREASE(n)
#define DEBUG_DECLARE(t,v)
#define DEBUG_SET(n,v)
#define DEBUG_MESSAGE(s)
#define DEBUG_PRINT(fd,s,v)
#define DEBUG_WRITE(fd,d,n)
#define DEBUG_TEMP(x)
#define DEBUG_BREAK		break
#define DEBUG_CONTINUE		continue
#define DEBUG_GOTO(label)	goto label
#define DEBUG_RETURN(x)		return(x)

#endif

#ifndef BREAK
#define BREAK			DEBUG_BREAK
#endif
#ifndef CONTINUE
#define CONTINUE		DEBUG_CONTINUE
#endif
#ifndef GOTO
#define GOTO(label)		DEBUG_GOTO(label)
#endif
#ifndef RETURN
#define RETURN(x)		DEBUG_RETURN(x)
#endif

#if _BLD_ast && defined(__EXPORT__)
#undef __MANGLE__
#define __MANGLE__ __LINKAGE__		__EXPORT__
#endif

extern __MANGLE__ double		debug_elapsed __PROTO__((int));
extern __MANGLE__ void		debug_indent __PROTO__((int));
extern __MANGLE__ void		debug_fatal __PROTO__((const char*, int, const char*));
#if 0 /* this prototype in <ast.h> for convenience */
extern __MANGLE__ ssize_t		debug_printf __PROTO__((int, const char*, ...));
#endif
extern __MANGLE__ ssize_t		debug_sprintf __PROTO__((char*, size_t, const char*, ...));
extern __MANGLE__ ssize_t		debug_vsprintf __PROTO__((char*, size_t, const char*, va_list));
extern __MANGLE__ ssize_t		debug_vprintf __PROTO__((int, const char*, va_list));
extern __MANGLE__ void		systrace __PROTO__((const char*));

#undef __MANGLE__
#define __MANGLE__ __LINKAGE__

#endif
